org.modeshape.jcr.spi.index

## Interface IndexManager

- All Superinterfaces:
    IndexManager

      public interface IndexManager
      extends IndexManager

  An interface for programmatically adding or removing index providers and index definitions.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `IndexProvider` | `getProvider(String name)` Get the query index provider registered with the given name.
    `void` | `register(IndexProvider provider)` Register a new already-instantiated `IndexProvider`.
    `void` | `unregister(String providerName)` Unregister the `IndexProvider` with the supplied name.

    - ### Methods inherited from interface org.modeshape.jcr.api.index.IndexManager

      `createIndexColumnDefinitionTemplate, createIndexDefinitionTemplate, getIndexDefinitions, getProviderNames, registerIndex, registerIndexes, unregisterIndexes`

- - ### Method Detail

    - #### getProvider

          IndexProvider getProvider(String name)

      Get the query index provider registered with the given name.
      Parameters:
        `name` - the name of the query index provider; may not be null
      Returns:
        the query index provider instance, or null if there is no provider registered with the supplied name

    - #### register

          void register(IndexProvider provider)
                        throws IndexProviderExistsException,
                               RepositoryException

      Register a new already-instantiated `IndexProvider`.
      Parameters:
        `provider` - the new provider instance; may not be null
      Throws:
        `IndexProviderExistsException` - if there is already an existing index provider with the same name
        `RepositoryException` - if there is a problem registering the provider

    - #### unregister

          void unregister(String providerName)
                          throws NoSuchProviderException,
                                 RepositoryException

      Unregister the `IndexProvider` with the supplied name.
      Parameters:
        `providerName` - the name of the query index provider; may not be null
      Throws:
        `NoSuchProviderException` - there is no index provider with the supplied name
        `RepositoryException` - if there is a problem unregistering the provider

Copyright © 2008-2014 JBoss, a division of Red Hat. All Rights Reserved.